#ifndef CFG_H
#define CFG_H

#pragma small			//memory model: small(data) compact(pdata) large(xdata)
#pragma rom(large) 		//code rom size: small(2k) compact(64k) large
#pragma ot(8, speed)	//code optimization: 1-11 size speed
#pragma intpromote		//Enable ANSI integer promotion rules:intpromote nointpromote
#pragma objectadvanced	//OBJECTADVANCED
//#pragma nomoddp2		//use multiple dptr: moddp2 nomoddp2
//#pragma REGFILE (.\A4.ORC)

//Զλ Options for target->LX51 Locate->User Segments  -> (ȫд)
//?PR?BACKUP_CODE?FX2_MAIN(C:0x0300)
//PRʾprogram Executable program code
//MyTestʾ
//MAINʾļ
//0x4000ʾԵַ


#include "intrins.h"
#include "binary.h"
#include "stc8h.h"

enum
{
	TAB_PWM,
	TAB_UART,
	TAB_NUM,
};

#ifdef ALLOCATE_EXTERN
	#define EXTERN
	#define _BIT_ sbit
	#define _AT_ _at_
	#define _BAT_ =
#else
	#define EXTERN extern
	#define _BIT_ bit
	#define _AT_ ;/ ## /
	#define _BAT_ ;/ ## /
#endif

EXTERN unsigned char bdata TAB[TAB_NUM] _AT_ 0x20;

EXTERN _BIT_ TAB_PWM0		_BAT_ TAB[TAB_PWM]^0;
EXTERN _BIT_ TAB_PWM1		_BAT_ TAB[TAB_PWM]^1;
EXTERN _BIT_ TAB_PWM2		_BAT_ TAB[TAB_PWM]^2;
EXTERN _BIT_ TAB_PWM3		_BAT_ TAB[TAB_PWM]^3;
EXTERN _BIT_ TAB_PWM4		_BAT_ TAB[TAB_PWM]^4;
EXTERN _BIT_ TAB_PWM5		_BAT_ TAB[TAB_PWM]^5;
EXTERN _BIT_ TAB_PWM6		_BAT_ TAB[TAB_PWM]^6;
EXTERN _BIT_ TAB_PWM7		_BAT_ TAB[TAB_PWM]^7;
	
EXTERN _BIT_ TAB_UART1_T2R		_BAT_ TAB[TAB_UART]^0;
EXTERN _BIT_ TAB_UART2_T2R		_BAT_ TAB[TAB_UART]^1;
EXTERN _BIT_ TAB_UART3_T2R		_BAT_ TAB[TAB_UART]^2;
EXTERN _BIT_ TAB_UART4_T2R		_BAT_ TAB[TAB_UART]^3;
EXTERN _BIT_ TAB_UART5		_BAT_ TAB[TAB_UART]^4;
EXTERN _BIT_ TAB_UART6		_BAT_ TAB[TAB_UART]^5;
EXTERN _BIT_ TAB_UART7		_BAT_ TAB[TAB_UART]^6;
EXTERN _BIT_ TAB_UART8		_BAT_ TAB[TAB_UART]^7;


#define sysclk	SYS7816
#define _nop_usb_()			{	if (sysclk> 6) _nop_();\
								if (sysclk>12) _nop_();\
								if (sysclk>18) _nop_();\
								if (sysclk>24) _nop_();\
								if (sysclk>30) _nop_();\
								if (sysclk>36) _nop_();\
								if (sysclk>42) _nop_();} //㹫ʽ 8 * sysclk / 48mhz - 1;

#define DIV7816 5

//ISR
extern void ISR_INT0();
extern void ISR_Timer0();
extern void ISR_INT1();
extern void ISR_Timer1();
extern void ISR_UART1();
extern void ISR_ADC();
extern void ISR_LVD();
extern void ISR_PCA();
extern void ISR_UART2();
extern void ISR_SPI();
extern void ISR_INT2();
extern void ISR_INT3();
extern void ISR_Timer2();
extern void ISR_INT4();
extern void ISR_UART3();
extern void ISR_UART4();
extern void ISR_Timer3();
extern void ISR_Timer4();
extern void ISR_CMP();
extern void ISR_I2C();
extern void ISR_USB();
extern void ISR_PWMA();
extern void ISR_PWMB();
extern void ISR_TKSU();
extern void ISR_RTC();
extern void ISR_P0();
extern void ISR_P1();
extern void ISR_P2();
extern void ISR_P3();
extern void ISR_P4();
extern void ISR_P5();
extern void ISR_P6();
extern void ISR_P7();
extern void ISR_DMA_M2M();
extern void ISR_DMA_ADC();
extern void ISR_DMA_SPI();
extern void ISR_DMA_UR1T();
extern void ISR_DMA_UR1R();
extern void ISR_DMA_UR2T();
extern void ISR_DMA_UR2R();
extern void ISR_DMA_UR3T();
extern void ISR_DMA_UR3R();
extern void ISR_DMA_UR4T();
extern void ISR_DMA_UR4R();
extern void ISR_DMA_LCM();
extern void ISR_LCM();
extern void ISR_Timer11();
extern void ISR_RETI();

extern void ISRP_INT0();
extern void ISRP_Timer0();
extern void ISRP_INT1();
extern void ISRP_Timer1();
extern void ISRP_UART1();
extern void ISRP_ADC();
extern void ISRP_LVD();
extern void ISRP_PCA();
extern void ISRP_UART2();
extern void ISRP_SPI();
extern void ISRP_INT2();
extern void ISRP_INT3();
extern void ISRP_Timer2();
extern void ISRP_INT4();
extern void ISRP_UART3();
extern void ISRP_UART4();
extern void ISRP_Timer3();
extern void ISRP_Timer4();
extern void ISRP_CMP();

extern void ISRP_I2C();
extern void ISRP_USB();
extern void ISRP_PWMA();
extern void ISRP_PWMB();
extern void ISRP_TKSU();
extern void ISRP_RTC();
extern void ISRP_P0();
extern void ISRP_P1();
extern void ISRP_P2();
extern void ISRP_P3();
extern void ISRP_P4();
extern void ISRP_P5();
extern void ISRP_P6();
extern void ISRP_P7();
extern void ISRP_DMA_M2M();
extern void ISRP_DMA_ADC();
extern void ISRP_DMA_SPI();
extern void ISRP_DMA_UR1T();
extern void ISRP_DMA_UR1R();
extern void ISRP_DMA_UR2T();
extern void ISRP_DMA_UR2R();
extern void ISRP_DMA_UR3T();
extern void ISRP_DMA_UR3R();
extern void ISRP_DMA_UR4T();
extern void ISRP_DMA_UR4R();
extern void ISRP_DMA_LCM();
extern void ISRP_LCM();
extern void ISRP_Timer11();
extern void ISRP_RETI();

#endif